Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman5.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman5.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman5.cs	(revision 17642)
@@ -1,39 +1,63 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman5 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.9.18 F = G*m1*m2/((x2-x1)^2+(y2-y1)^2+(z2-z1)^2)"; } }
+  public class Feynman5 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "F"; } }
-    protected override string[] VariableNames { get { return new string[] { "m1", "m2", "G", "x1", "x2", "y1", "y2", "z1", "z2", "F"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"m1", "m2", "G", "x1", "x2", "y1", "y2", "z1", "z2"}; } }
+    public Feynman5() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman5(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman5(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get {
+        return string.Format("Feynman I.9.18 G*m1*m2/((x2-x1)**2+(y2-y1)**2+(z2-z1)**2) | {0} samples",
+          trainingSamples);
+      }
+    }
+
+    protected override string TargetVariable { get { return "F"; } }
+
+    protected override string[] VariableNames {
+      get { return new[] {"m1", "m2", "G", "x1", "x2", "y1", "y2", "z1", "z2", "F"}; }
+    }
+
+    protected override string[] AllowedInputVariables {
+      get { return new[] {"m1", "m2", "G", "x1", "x2", "y1", "y2", "z1", "z2"}; }
+    }
 
     public int Seed { get; private set; }
 
-    public Feynman5() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman5(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
       var data = new List<List<double>>();
-      var m1 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
-      var m2 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
-      var G = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
-      var x1 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 4).ToList();
-      var x2 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
-      var y1 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 4).ToList();
-      var y2 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
-      var z1 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 4).ToList();
-      var z2 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
+      var m1   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
+      var m2   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
+      var G    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
+      var x1   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 4).ToList();
+      var x2   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
+      var y1   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 4).ToList();
+      var y2   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
+      var z1   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 4).ToList();
+      var z2   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
 
       var F = new List<double>();
@@ -50,9 +74,9 @@
       data.Add(F);
 
-      for (var i = 0; i < x1.Count; i++) {
-        var res = G[i] * m1[i] * m2[i] / (Math.Pow(x2[i] - x1[i], 2) + Math.Pow(y2[i] - y1[i], 2) + Math.Pow(z2[i] - z1[i], 2));
+      for (var i = 0; i < m1.Count; i++) {
+        var res = G[i] * m1[i] * m2[i] /
+                  (Math.Pow(x2[i] - x1[i], 2) + Math.Pow(y2[i] - y1[i], 2) + Math.Pow(z2[i] - z1[i], 2));
         F.Add(res);
       }
-
 
       return data;
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman50.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman50.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman50.cs	(revision 17642)
@@ -6,5 +6,24 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman50 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman I.48.2 m*c**2/sqrt(1-v**2/c**2)"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman50() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman50(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman50(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.48.2 m*c**2/sqrt(1-v**2/c**2) | {0} samples", trainingSamples); }
+    }
 
     protected override string TargetVariable { get { return "E_n"; } }
@@ -14,9 +33,8 @@
     public int Seed { get; private set; }
 
-    public Feynman50() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman50(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman51.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman51.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman51.cs	(revision 17642)
@@ -6,5 +6,26 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman51 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman I.50.26 x1*(cos(omega*t)+alpha*cos(omega*t)**2)"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman51() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman51(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman51(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get {
+        return string.Format("Feynman I.50.26 x1*(cos(omega*t)+alpha*cos(omega*t)**2) | {0} samples", trainingSamples);
+      }
+    }
 
     protected override string TargetVariable { get { return "x"; } }
@@ -14,9 +35,8 @@
     public int Seed { get; private set; }
 
-    public Feynman51() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman51(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman52.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman52.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman52.cs	(revision 17642)
@@ -6,5 +6,24 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman52 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman II.2.42 kappa*(T2-T1)*A/d"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman52() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman52(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman52(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman II.2.42 kappa*(T2-T1)*A/d | {0} samples", trainingSamples); }
+    }
 
     protected override string TargetVariable { get { return "Pwr"; } }
@@ -14,9 +33,8 @@
     public int Seed { get; private set; }
 
-    public Feynman52() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman52(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman53.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman53.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman53.cs	(revision 17642)
@@ -6,5 +6,24 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman53 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman II.3.24 Pwr/(4*pi*r**2)"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman53() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman53(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman53(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman II.3.24 Pwr/(4*pi*r**2) | {0} samples", trainingSamples); }
+    }
 
     protected override string TargetVariable { get { return "flux"; } }
@@ -14,9 +33,8 @@
     public int Seed { get; private set; }
 
-    public Feynman53() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman53(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman54.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman54.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman54.cs	(revision 17642)
@@ -6,5 +6,24 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman54 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman II.4.23 q/(4*pi*epsilon*r)"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman54() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman54(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman54(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman II.4.23 q/(4*pi*epsilon*r) | {0} samples", trainingSamples); }
+    }
 
     protected override string TargetVariable { get { return "Volt"; } }
@@ -14,9 +33,8 @@
     public int Seed { get; private set; }
 
-    public Feynman54() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman54(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman55.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman55.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman55.cs	(revision 17642)
@@ -6,5 +6,26 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman55 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman II.6.11 1/(4*pi*epsilon)*p_d*cos(theta)/r**2"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman55() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman55(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman55(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get {
+        return string.Format("Feynman II.6.11 1/(4*pi*epsilon)*p_d*cos(theta)/r**2 | {0} samples", trainingSamples);
+      }
+    }
 
     protected override string TargetVariable { get { return "Volt"; } }
@@ -14,9 +35,8 @@
     public int Seed { get; private set; }
 
-    public Feynman55() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman55(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman56.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman56.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman56.cs	(revision 17642)
@@ -6,5 +6,27 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman56 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman II.6.15a p_d/(4*pi*epsilon)*3*z/r**5*sqrt(x**2+y**2)"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman56() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman56(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman56(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get {
+        return string.Format("Feynman II.6.15a p_d/(4*pi*epsilon)*3*z/r**5*sqrt(x**2+y**2) | {0} samples",
+          trainingSamples);
+      }
+    }
 
     protected override string TargetVariable { get { return "Ef"; } }
@@ -14,9 +36,8 @@
     public int Seed { get; private set; }
 
-    public Feynman56() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman56(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
@@ -42,5 +63,6 @@
 
       for (var i = 0; i < epsilon.Count; i++) {
-        var res = p_d[i] / (4 * Math.PI * epsilon[i]) * 3 * z[i] / Math.Pow(r[i], 2) * Math.Sqrt(Math.Pow(x[i], 2) + Math.Pow(y[i], 2));
+        var res = p_d[i] / (4 * Math.PI * epsilon[i]) * 3 * z[i] / Math.Pow(r[i], 2) *
+                  Math.Sqrt(Math.Pow(x[i], 2) + Math.Pow(y[i], 2));
         Ef.Add(res);
       }
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman57.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman57.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman57.cs	(revision 17642)
@@ -6,5 +6,27 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman57 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman II.6.15b p_d/(4*pi*epsilon)*3*cos(theta)*sin(theta)/r**3"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman57() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman57(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman57(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get {
+        return string.Format("Feynman II.6.15b p_d/(4*pi*epsilon)*3*cos(theta)*sin(theta)/r**3 | {0} samples",
+          trainingSamples);
+      }
+    }
 
     protected override string TargetVariable { get { return "Ef"; } }
@@ -14,9 +36,8 @@
     public int Seed { get; private set; }
 
-    public Feynman57() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman57(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman58.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman58.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman58.cs	(revision 17642)
@@ -6,5 +6,24 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman58 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman II.8.7 3/5*q**2/(4*pi*epsilon*d)"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman58() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman58(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman58(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman II.8.7 3/5*q**2/(4*pi*epsilon*d) | {0} samples", trainingSamples); }
+    }
 
     protected override string TargetVariable { get { return "E_n"; } }
@@ -14,9 +33,8 @@
     public int Seed { get; private set; }
 
-    public Feynman58() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman58(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman59.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman59.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman59.cs	(revision 17642)
@@ -6,5 +6,24 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman59 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman II.8.31 epsilon*Ef**2/2"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman59() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman59(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman59(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman II.8.31 epsilon*Ef**2/2 | {0} samples", trainingSamples); }
+    }
 
     protected override string TargetVariable { get { return "E_den"; } }
@@ -14,9 +33,8 @@
     public int Seed { get; private set; }
 
-    public Feynman59() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman59(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman6.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman6.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman6.cs	(revision 17642)
@@ -1,34 +1,48 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman6 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.10.7 m = m_0/sqrt(1-v^2/c^2)"; } }
+  public class Feynman6 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "m"; } }
-    protected override string[] VariableNames { get { return new string[] { "m_0", "v", "c", "m"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"m_0", "v", "c"}; } }
+    public Feynman6() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman6(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman6(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.10.7 m_0/sqrt(1-v**2/c**2) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "m"; } }
+    protected override string[] VariableNames { get { return new[] {"m_0", "v", "c", "m"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"m_0", "v", "c"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman6() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman6(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
       var data = new List<List<double>>();
-      var m_0 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var v = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
-      var c = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 10).ToList();
-
+      var m_0  = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var v    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
+      var c    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 10).ToList();
 
       var m = new List<double>();
@@ -39,9 +53,8 @@
       data.Add(m);
 
-      for (var i = 0; i < v.Count; i++) {
+      for (var i = 0; i < m_0.Count; i++) {
         var res = m_0[i] / Math.Sqrt(1 - Math.Pow(v[i], 2) / Math.Pow(c[i], 2));
         m.Add(res);
       }
-
 
       return data;
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman60.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman60.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman60.cs	(revision 17642)
@@ -6,5 +6,24 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman60 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman II.10.9 sigma_den/epsilon*1/(1+chi)"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman60() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman60(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman60(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman II.10.9 sigma_den/epsilon*1/(1+chi) | {0} samples", trainingSamples); }
+    }
 
     protected override string TargetVariable { get { return "Ef"; } }
@@ -14,9 +33,8 @@
     public int Seed { get; private set; }
 
-    public Feynman60() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman60(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
